using Microsoft.EntityFrameworkCore;
using System.ComponentModel.DataAnnotations.Schema;

namespace Elwig.Models.Entities {
    [Table("payment_delivery_part_bucket"), PrimaryKey("Year", "DId", "DPNr", "BktNr", "AvNr")]
    public class PaymentDeliveryPartBucket {
        [Column("year")]
        public int Year { get; set; }

        [Column("did")]
        public int DId { get; set; }

        [Column("dpnr")]
        public int DPNr { get; set; }

        [Column("bktnr")]
        public int BktNr { get; set; }

        [Column("avnr")]
        public int AvNr { get; set; }

        [Column("price")]
        public long PriceValue { get; set; }
        [NotMapped]
        public decimal Price {
            get => Variant.Season.DecFromDb(PriceValue);
            set => PriceValue = Variant.Season.DecToDb(value);
        }

        [Column("amount")]
        public long AmountValue { get; set; }
        [NotMapped]
        public decimal Amount {
            get => Variant.Season.DecFromDb(AmountValue);
            set => AmountValue = Variant.Season.DecToDb(value);
        }

        [ForeignKey("Year, AvNr")]
        public virtual PaymentVar Variant { get; private set; } = null!;

        [ForeignKey("Year, DId, DPNr")]
        public virtual DeliveryPart DeliveryPart { get; private set; } = null!;
    }
}
